# coding:cp932

"""Femtet [eBeB W[

       * Femtet𑀍삷邽߂̃W[

"""
from logging import getLogger
from pathlib import Path
from subprocess import Popen, SubprocessError, TimeoutExpired
import time
import winreg

import win32api
import win32con
from win32com.client import Dispatch
import win32process

from femtetutils.constant import FemtetClassName as femtetconst

logger = getLogger(__name__)


class Data:
    def __init__(self):
        # NXϐCX^Xʂɗp̂ŃRXgN^Œ`
        self.general_process_id = 0  # NFemtetȊÕvZXID
        self.femtet_process_id = 0   # NFemtet̃vZXID
        self.femtet_hwnd = 0         # Femtet̃EBhEnh


def get_femtet_exe_path():
    """Femtet.exePath擾

    WXg񂩂AFemtet.exẽpX擾֐

    :return: Femtet.exẽpX
    : 'C:\\Program Files\\Femtet_Ver2023_64bit\\Program\\Femtet.exe'
    :rtype: str
    """

    dllpath = _get_femtetmacro_dllpath()
    if dllpath is None:
        return None
    workpath = Path(dllpath)
    dirtpl = workpath.parts
    dirlist = list(dirtpl)

    if dirlist[-2] == r"Macro32":
        del dirlist[-2:]
    else:
        del dirlist[-1:]

    dirlist.append(r"Femtet.exe")

    dirlist[0] = dirlist[0].removesuffix('\\')
    execpath = '\\'.join(dirlist)
    logger.info(execpath)
    return execpath


def execute_femtet():
    """Femtet.exe̋N

    Femtet.exeN

    :return: True:vZXN, False:vZXNłȂ
    :rtype: bool
    """

    Data.femtet_process_id = 0

    femtetpath = get_femtet_exe_path()
    if femtetpath is None:
        return False

    try:
        # windowsOSłCreateProcessĂяoĂ
        proc = Popen(femtetpath)
        while proc.poll() is not None:
            pass

        if proc.poll() is None:
            logger.info("Femtet process is executed. Process id = %s"
                        % proc.pid)
            Data.femtet_process_id = proc.pid
            return True
        else:
            logger.warning("Femtet process is terminated. returncode = %s"
                           % proc.returncode)
            return False
    except SubprocessError as e:
        logger.error("Catch SubprocessError.")
        logger.error(e)
        return False


def execute_process(command, timeout_second=None):
    """vZX̋N

    w肵vZXN

    :param command: NvZX̃pX
    : "notepad.exe"
    :type command: str
    :param timeout_second: w莞ԂɂȂ܂ŁAvZX̏I҂܂
    :type timeout_second: int(b)
    :return: True:vZXN, False:vZXNłȂ
    :rtype: bool
    :return: [N] vZX̏IR[h
            [G[̏ꍇ] -1:^CAEg, -2:vZXOG[
    :rtype: int
    """

    Data.general_process_id = 0
    try:
        proc = Popen(command)
        while proc.poll() is not None:
            pass

        if proc.poll() is None:
            logger.info("Process is executed. Process id = %s" % proc.pid)
            Data.general_process_id = proc.pid
        else:
            logger.warning("Process is terminated. returncode = %s"
                           % proc.returncode)
            return False

        if timeout_second is not None:
            logger.info("About %s seconds waiting for the process to finish."
                        % timeout_second)
            proc.wait(timeout_second)
            logger.info("Process is terminated. returncode = %s"
                        % proc.returncode)

        return True, proc.returncode
    except TimeoutExpired:
        logger.warning("Waiting for the process is timed out.")
        return False, -1
    except SubprocessError as e:
        logger.error("Catch SubprocessError.")
        logger.error(e)
        return False, -2


def get_last_executed_process_id():
    """OɋNvZX̃vZXID擾

    execute_process()ŋNvZXID擾
    OɋNvZX̂ݎ擾\

    :return: vZXID(݂Ȃꍇ0)
    :rtype: int
    """

    return Data.general_process_id


def get_last_executed_femtet_process_id():
    """OɋNFemtet.exẽvZXID擾

    execute_femtet()ŋNvZXID擾
    OɋNvZX̂ݎ擾\

    :return: vZXID(݂Ȃꍇ0)
    :rtype: int
    """

    return Data.femtet_process_id


def auto_execute_femtet(wait_second=60):
    """Femtet.exe̋N(gpFemtet݂Ȃꍇ)

    Femtet1NĂȂA܂͊FemtetׂĎgp̏ꍇFemtetN

    :param wait_second: N܂Ŏw莞ԑҋ@܂
    :type wait_second: int(b)
    :return: True:gpFemtetN܂͐VKFemtetN, False:FemtetNłȂ
    :rtype: bool
    """

    # execute_femtet֐łĂ邪A
    # ֐sɏ𔲂ꍇ̂ŁAłĂ
    Data.femtet_process_id = 0
    Data.hWnd = 0

    wkFemtet = _dispatch_femtet()
    if wkFemtet.hWnd != 0:
        logger.info("Free Femtet is running. hWnd = %s" % wkFemtet.hWnd)
        return True

    # VFemtet̋N
    if not execute_femtet():
        # NɎsB͋NɎԂĂB
        logger.warning("New Femtet falied to start.")
        return False

    # ̎_ŎN͂ĂԁFemtetMainFrameoĂȂ\cĂ
    # #6849 HASP̃_CAOFĂ܂߁A{FemtetN܂ő҂B

    wait_time = wait_second * 2     # [v0.5bҋ@Ă̂2|
    for i in range(wait_time):
        if wkFemtet.hWnd != 0:
            # hWndLƂƂ̓}NʐMłFemtetƂƁB{֐̖ړIBB
            # hWndvpeB̓}NʐMłFemtetMainFrameȊOɂ̓ZbgȂdlȂ̂ŐM100%
            Data.femtet_hwnd = wkFemtet.hWnd
            break
        time.sleep(0.5)

    if wkFemtet.hWnd != 0:
        logger.info("New Femtet is activated. hWnd = %s" % wkFemtet.hWnd)
        return True
    else:
        logger.warning("New Femtet is not activated.")
        return False


def get_process_id_from_hwnd(hwnd):
    """vZXID̎擾

    w肳ꂽEBhEnhvZXID擾

    :param hwnd: CFemtet.hWndvpeBZbg
    :type hwnd: int
    :return: vZXID(擾łȂꍇ0߂)
    :rtype: int
    """
    thread, process = _get_thread_and_process_id_from_hwnd(hwnd)
    ret = process if thread != 0 else thread    # vZXID擾łȂꍇthread0
    logger.info("Process id:{0}".format(ret))
    return ret


def is_femtet_active():
    """Femtet.exeN

    Femtet.exe݋NĂ邩𔻒肷

    :return: True:N, False:NĂȂ
    :rtype: bool
    """
    wkFemtet = _dispatch_femtet()
    return (wkFemtet.hWnd != 0)


def close_femtet(hwnd, wait_second=60, isTerminate=True):
    """w肵EBhEnhFemtet.exe

    Femtet.exẽEBhEnhɎw肵AΏۂFemtet.exeB

    :param hwnd:Femtet̃EBhEnh
        ⑫:CFemtet.hWndŃ}NɊ֘AtꂽEBhEnh擾\B
    :type hwnd: int
    :param wait_second: ܂őҋ@ső厞(b)
    :type wait_second: int
    :param isTerminate: 邱ƂoȂꍇAI邩
        True:I, False:IȂ
    :type isTerminate: bool

    :return: True:Femtet, False:Femtetԓɕ邱ƂłȂ
    :rtype: bool
    """

    _post_wm_close_message(hwnd)    # close

    wait_time = wait_second * 2     # [v0.5bҋ@Ă̂2|
    for i in range(wait_time):
        thread, process = _get_thread_and_process_id_from_hwnd(hwnd)
        if thread == 0:
            Data.femtet_hwnd = 0
            Data.femtet_process_id = 0
            logger.info("Femtet is closed.")
            return True     # ƂmF
        time.sleep(0.5)

    # w莞Ԍ܂Ń[vꍇ́AŏI`FbN
    thread, process = _get_thread_and_process_id_from_hwnd(hwnd)
    if thread == 0:
        Data.femtet_hwnd = 0
        Data.femtet_process_id = 0
        return True
    else:
        if isTerminate:
            if _terminate_process(process):
                logger.warning("Femtet is terminated.")
                if _is_long_wait():
                    # IƁA\tgEFACZX(LDK)̔F؃JEgJȂ߁A
                    # FemtetN܂3x҂ȂƂȂB
                    logger.info("About 5 minutes waiting for license release.")
                    # ]T邽5҂
                    time_left = 300
                    time_interval = 15
                    wait_count = time_left // time_interval
                    for i in range(wait_count):
                        time.sleep(time_interval)
                        time_left -= time_interval
                        logger.info("{0} seconds left.".format(time_left))
            else:
                logger.warning("Can not close Femtet.")
        else:
            logger.warning("Can not close Femtet.")
        return False


def close_process(process_id):
    """w肵vZXID̃vZX(I)

    vZXIDw肷ƑΏۂ̃vZX(I)B

    :param process_id: vZXID
    :type process_id: int
    :return: True:vZXI, False:IɃG[
    :rtype: bool
    """

    ret = _terminate_process(process_id)
    if ret:
        Data.general_process_id = 0
        logger.info(
            "Process is terminated. Process id = {0}".format(process_id))

    return ret


def _dispatch_femtet():
    return (Dispatch(femtetconst.CFemtet))


def _get_thread_and_process_id_from_hwnd(hwnd):
    return (win32process.GetWindowThreadProcessId(hwnd))


def _get_femtetmacro_dllpath():
    dllpath = _get_femtetmacro_dllpath_64()
    if dllpath is None:
        return _get_femtetmacro_dllpath_32()
    else:
        return dllpath


def _get_femtetmacro_dllpath_64():
    """FemtetMacro.dll(64bitp)Path擾

    WXg̃^CvCu񂩂AFemtetMacro.dllpX擾֐

    :return: FemtetMacro.dll(64bitp)̃pX
    : "C:\\Program Files\\Femtet_Ver2023_64bit\\Program\\FemtetMacro.dll"
    :rtype: str
    """

    # l擾łȂFileNotFoundError̂
    # ̏ꍇNone߂lƂ
    try:
        key = winreg.OpenKey(
            winreg.HKEY_LOCAL_MACHINE,
            r"SOFTWARE\Classes\TypeLib\{7D1A10D9-22CE-4EDE-80FB-26A1E307D9FA}\1.0\0\win64",
            access=winreg.KEY_READ)
        value = winreg.QueryValue(key, "")
        return value
    except FileNotFoundError:
        return None


def _get_femtetmacro_dllpath_32():
    """FemtetMacro.dll(32bitp)Path擾

    WXg̃^CvCu񂩂AFemtetMacro.dllpX擾֐

    :return: FemtetMacro.dll(32bitp)̃pX
    : "C:\\Program Files\\Femtet_Ver2023_64bit\\Program\\Macro32\\FemtetMacro.dll"
    :rtype: str
    """

    # l擾łȂFileNotFoundError̂
    # ̏ꍇNone߂lƂ
    try:
        key = winreg.OpenKey(
            winreg.HKEY_LOCAL_MACHINE,
            r"SOFTWARE\Classes\TypeLib\{7D1A10D9-22CE-4EDE-80FB-26A1E307D9FA}\1.0\0\win32",
            access=winreg.KEY_READ)
        value = winreg.QueryValue(key, "")
        return value
    except FileNotFoundError:
        return None


def _is_long_wait():
    dllpath = _get_femtetmacro_dllpath()
    if dllpath is None:
        return True
    return not ('_inside' in dllpath)


def _post_wm_close_message(hwnd):
    # vWFNgۑ̏ꍇ͕ۑ_CAOôŕs\
    win32api.PostMessage(hwnd, win32con.WM_CLOSE, 0, 0)


def _terminate_process(process_id):
    # https://learn.microsoft.com/ja-jp/windows/win32/debug/system-error-codes--1000-1299-
    ERROR_PROCESS_ABORTED = 0x042B
    try:
        handle = win32api.OpenProcess(1, False, process_id)
        win32api.TerminateProcess(handle, ERROR_PROCESS_ABORTED)
        # win32process.TerminateProcess(handle, ERROR_PROCESS_ABORTED)
        win32api.CloseHandle(handle)
        return True
    except Exception as e:
        logger.error("Terminate process Error.")
        logger.error(e)
        return False
